from flask import render_template
from flask import current_app
from app.email import mail, Message
import os

from threading import Thread


def send_async_email(app, msg):
    with app.app_context():
        mail.send(msg)


def send__report_email(users, date):
    # Get files
    filenames = []
    path_list = []
    for (dir_path, dir_names, path) in os.walk(current_app.config['UPLOAD_FOLDER']):
        path_list = [os.path.join(dir_path, p) for p in path]
        print(f"Admin reports: {path_list}")
        filenames.extend(path)
        break


    for user in users:
        message = render_template('email/send_reports.html', user=user, date=date)
        html = render_template('email/send_reports.txt', user=user, date=date)
        subject = 'Crave reports from {}'.format(date)
        msg = Message(sender=current_app.config["REPORT_FROM"],
                      body=message,
                      subject=subject,
                      html=html
                      )

        msg.add_recipient(user.email)
        for file, path in zip(filenames, path_list):

            with current_app.open_resource(path) as fp:
                msg.attach(file, "application/vnd.ms-excel", fp.read())

        Thread(target=send_async_email, args=(current_app._get_current_object(), msg)).start()


def send_single_report(user, file, date):

    message = render_template('email/send_reports.html', user=user, date=date)
    html = render_template('email/send_reports.txt', user=user, date=date)
    subject = 'Crave reports from {}'.format(date)
    msg = Message(sender=current_app.config["REPORT_FROM"],
                  body=message,
                  subject=subject,
                  html=html)
    msg.add_recipient(user.email)
    file = os.path.basename(file)
    path = os.path.join(current_app.config['UPLOAD_FOLDER'], file)
    with current_app.open_resource(path) as fp:
        msg.attach(file, "application/vnd.ms-excel", fp.read())

    Thread(target=send_async_email, args=(current_app._get_current_object(), msg)).start()
